#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <iostream.h>
#include <graphics.h>
#include <bios.h>
#include <mem.h>
#include <dos.h>


template <class T> class CMAT
{
private: 	int m;
		int n;
		int *p;

public:  	CMAT(){};
		CMAT(int, int);
		void input();
		friend CMAT operator+(CMAT&, CMAT&);
		friend CMAT operator*(CMAT&, CMAT&);
		T opred();
		CMAT vich(int,int);
		void output();
};


template <class T> CMAT<T>::CMAT(int a, int b)
{
	m=a;
	n=b;
	p=new int[m*n];
}



template <class T> void CMAT<T>::input()
{
	for(int i=0; i<m; i++)
	{
		for(int j=0; j<n; j++)
				cin>>*(p+i*n+j);
	}
}

template <class T> CMAT<T> operator+(CMAT<T> &obj1, CMAT<T> &obj2)
{
	int i, j, x=10, y=10, color=1;
	float skip;
	CMAT<T>  t(obj1.m, obj1.n);
	for(i=0; i<obj1.m; i++)
	{
		for(j=0; j<obj1.n; j++)
		{
			if (color<15) color++;
			else color=1;
			textcolor(color);
			gotoxy(x, y);
			cprintf("%i", obj1.p[i*obj1.n+j]);
			gotoxy(x+50, y);
			cprintf("%i", obj2.p[i*obj1.n+j]);
			t.p[i*obj1.n+j]=obj1.p[i*obj1.n+j]+obj2.p[i*obj1.n+j];
			gotoxy(x+25, y+25);
			cprintf("%i", t.p[i*obj1.n+j]);
			x=x+3;
			getch();
		}
		x=10;
		y=y+3;
	}
	return t;
}



template <class T> CMAT<T> operator*(CMAT<T> &obj1, CMAT<T> &obj2)
{
	int xpos=2, ypos=3, color=1, x2=42, y2=3;
	float skip;
	CMAT<T>  t(obj1.m, obj1.n);

	for(int i=0; i<obj1.m; i++)
	{
		for(int j=0; j<obj2.n; j++)
		{

			t.p[i*obj1.n+j]=0;
			if (color==10) color=11;
			else color=10;
			textcolor(color);
			x2=x2+3;
			for(int fl=0; fl<obj1.n; fl++)
			{
				xpos+=3;
				gotoxy(xpos, ypos);
				cprintf("%d", obj1.p[i*obj1.n+fl]);
				gotoxy(x2, y2);
				cprintf("%d", obj2.p[fl*obj2.n+j]);
				t.p[i*obj1.n+j]=t.p[i*obj1.n+j]+(obj1.p[i*obj1.n+fl]*obj2.p[fl*obj2.n+j]);
				y2+=2;
			}
			gotoxy(xpos+20+j*4, ypos+16);
			cprintf("%d", t.p[i*obj1.n+j]);
			xpos=2;
			y2=3;
			delay(1000);
		}
		xpos=2;
		x2=42;
		ypos+=2;
	}
	return t;
}

/*template <class T> T CMAT<T>::opred()
{
	CMAT<T> temp(10,10);

}*/

template <class T> CMAT<T> CMAT<T>::vich(int l, int m2)
{
	CMAT<T> temp(m-1,n-1);
	for(int i=0;i<m;i++)
	{
		if(i==l) continue;
		for(int j=0;j<n;j++)
		{
			if(j==m2) continue;
			temp.p[i*n+j]=p[i*n];
		}
	}
	return temp;
}

template <class T> void CMAT<T>::output()
{
	int i, j, x=10, y=10, color=1;
	float skip;
	for(i=0; i<m; i++)
	{
		for(j=0; j<n; j++)
		{
			if (color<15) color++;
			else color=1;
			textcolor(color);
			gotoxy(x, y);
			cprintf("%i", p[i*n+j]);
			gotoxy(x+50, y);
			cprintf("%i", p[i*n+j]);
			x=x+3;
			getch();
		}
		x=10;
		y=y+3;
	}

}


void main()
{
	clrscr();
	int m1, n1, l1, i, j;

	cout<<" m, n, l"<<endl;
	cin>>m1>>n1/*>>l1*/;
	CMAT<int> A(m1, n1);
	CMAT<int> temp(m1,n1);
	//CMAT<int> B(n1, l1);
	//CMAT<int> C(m1, l1);
	clrscr();
	cout<<"Mat 1 ("<<m1<<", "<<n1<<"):\n";
	A.input();
	//clrscr();
	//cout<<"Mat 2 ("<<n1<<", "<<l1<<"):\n";
	//B.input();
	clrscr();
	//C=A*B;
	A.output();
	clrscr();
	temp=A.vich(1,1);
	temp.output();



	getch();
}
























